<?php
set_include_path(get_include_path() . PATH_SEPARATOR . 'phpseclib');
include('Crypt/RSA.php');

$privateKey = <<<EOF
-----BEGIN RSA PRIVATE KEY-----
MIICXgIBAAKBgQClLIJjfqHIPYut03pEub6DMvAFv3TDPIO/k/qC3ROlK1Ng6U2t
bHFABCOgINDne/esVwNzRYAs5Jii1YsnK5nKvdR2GNRNRT2qPL5m18qjxwiIRwBf
ZEa83WSPCt9hMmA5J5PyxWaBu47+fKv+I9l9YygQSDTmXeTvZmTF7L5HFwIDAQAB
AoGBAJxFqTNjGsOt3xpdy/970RCmP8rgYiNZfLjj046+hZiujhtRgGmFAPz1LZOR
mLR6aFDInn4QEn3m5bah3R75NG3EGXR7205R0c1IWMq/uT9Wu+XtmmA5ECxETMEt
ESXJR9zF0n2USTH3R6uhkYqtVCZMoqtprhI/9/a+Tx+T3k/ZAkEA2yXbILCYMzWO
p5uyePROuqyLd4Fy7R03XwGfXUqrORIAqHRC6x2aS6MRx4XCt1F2/W4IRkILU2g4
lRZGY1aMowJBAMDzHVTph3GT2OdIs1pIhgXicbROmzLPWF10tEZqbv3R1cwU5q7H
COcILG7fwRQoQdjvHR/c+2jo3dllMsBQLv0CQQDOVYlI8RyMcqu7IbxbZ+NMnbK+
tVII8M42lKeAxhIKrOmTsctj5b5l4saVrlpUEc7P9K6zv/E7+c/0h0GEvHOzAkAK
ROYqvsMWqGfC53ukMnfvmD20+voHmkF5t9xgYwnFOIXIdtRQOQegRC8ZN49vIzVd
9lv2dixrSPmFuH0a/ymBAkEArB6hQXddvOIjyXbC8XdHDDef9Wh6i53fwVqBy+Lu
3PFinCKCM/WqarvlAfzyHnV+HVkhaD8BVDix+0b/TaYLNw==
-----END RSA PRIVATE KEY-----
EOF;

$publicKey = <<<EOF
-----BEGIN PUBLIC KEY-----
MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQClLIJjfqHIPYut03pEub6DMvAF
v3TDPIO/k/qC3ROlK1Ng6U2tbHFABCOgINDne/esVwNzRYAs5Jii1YsnK5nKvdR2
GNRNRT2qPL5m18qjxwiIRwBfZEa83WSPCt9hMmA5J5PyxWaBu47+fKv+I9l9YygQ
SDTmXeTvZmTF7L5HFwIDAQAB
-----END PUBLIC KEY-----
EOF;


$rsa = new Crypt_RSA();

switch($_GET["action"]) {
    case "getKeys":
        echo json_encode(array(
            "public" => $publicKey,
            "private" => $privateKey,
        ));
        exit(); break;

    case "decrypt":
        $rsa->loadKey($privateKey); 
        $rsa->setEncryptionMode(CRYPT_RSA_ENCRYPTION_PKCS1);
        echo $rsa->decrypt(base64_decode($_POST["encryptedPayload"]));
        exit(); break;

    case "encrypt":
        $rsa->loadKey($publicKey); 
        $rsa->setEncryptionMode(CRYPT_RSA_ENCRYPTION_PKCS1);
        echo base64_encode($rsa->encrypt($_POST["plaintextdPayload"]));
        exit(); break;
}
?>
<html>
<head>
    <script src="jsencrypt/jsencrypt.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.1.1/jquery.min.js"></script>
    <script>
    $(function() {
        var publicKey = "";
        var privateKey = "";

        $.ajaxSetup({async:false});

        // Step 0) Get Public and Private Key
        $.getJSON('bidirectional.php?action=getKeys', function(response) {
            publicKey = response.public;
            privateKey = response.private;
            log("... received public and private keys");
        });
        
        $('#btnDemo').click(function(e) {
            e.preventDefault();
            var payload = $('#tbPayload').val();
        
            // 1) Encrypt the Payload using the Publickey
            log("JS: Original Payload => " + payload);
            var crypt = new JSEncrypt();
            crypt.setPublicKey(publicKey);
            var encrypted = crypt.encrypt(payload);
            log("JS: Encrypted Payload => " + encrypted);


            // 2) Decrypt with JS
            crypt.setPrivateKey(privateKey);
            var decrypted = crypt.decrypt(encrypted);
            log("JS: Decrypted Payload => " + decrypted);


            // 3) Send Encrypted Text to PHP 
            $.post('bidirectional.php?action=decrypt', {encryptedPayload: encrypted}, function(response) {
                log("PHP: Decrypted the Payload which was encrypted with JS => " + response);
            });


            // 4) Send Plaintext PayloadText to PHP 
            $.post('bidirectional.php?action=encrypt', {plaintextdPayload: payload}, function(response) {
                log("PHP: Encrypted the plaintext Payload =>" + response);

                crypt.setPrivateKey(privateKey);
                var decrypted = crypt.decrypt(response);
                log("JS: Decrypted the Payload which was encrypted with Payload => " + decrypted);
            });            
        });

        function log(msg) {
            $('#log').val($('#log').val() + msg + "\n\n\n");
        }
        
    }); 
    </script>
</head>
<body>
    <input type="text" id="tbPayload" value="Hallo Welt">
    <input type="button" id="btnDemo" value="Demo">
    <br>
    <textarea rows="30" cols="190" id="log"></textarea>
</body>
</html>
